<?php
/**
    Explorer : Plugin for GuppY 4.5 and 4.6
    under CeCILL v2 Free Software Agreement
    Initial version by Kimai: http://michaeldouchin.free.fr/demo/
    Rewrited, secured and enhanced by Hpsam : http://www.hpsam.info/
*/

header("Pragma: no-cache");
define("CHEMIN", "../../");
include(CHEMIN."inc/includes.inc");
include(CHEMIN."inc/hpage.inc");

// Find plugin name (in case of duplication)
$explorer_folder = explode('/', str_replace('\\', '/', dirname(__FILE__)));
$explorer_folder = $explorer_folder[count($explorer_folder) - 1];
$explorer_name   = ucfirst($explorer_folder);

include(CHEMIN . 'plugins/' . $explorer_folder . '/lang/' . $lng . '-exp-web.inc');
include(CHEMIN . DATAREP . 'plugins/' . $explorer_folder . '/configuration.inc');

/**
 * Sort a bi level array by one of his column
 *
 * @param array $array Array to sort
 * @param string $sortRow Index of the row use for the sort
 * @param string $sortType Sort direction SORT_DESC, SORT_ASC...
 * @return array The sorted array
 */
function exp_sortData($array, $sortRow, $sortType) {
    foreach ($array as $key => $row) {
        $tri[$key] = strtolower($row[$sortRow]);
    }
    if (is_array($tri)) {
        array_multisort($tri, $sortType, $array);
    }
    return $array;
}

/**
 * Function to display the file size in ko, Mo
 *
 * @param unknown_type $size
 * @return unknown
 */
function convertSize($size) {
    global $exp_web5;
    $ko = 1024;        // kilo Bytes
    $mo = 1024 * $ko;  // Mega Bytes
    $go = 1024 * $mo;  // Giga Bytes
    $to = 1024 * $go;  // Tera Bytes
    if ($size == 0)  return $exp_web5[0];
    if ($size < $ko) return sprintf($exp_web5[1], $size);
    if ($size < $mo) return sprintf($exp_web5[2], $size / $ko, 2);
    if ($size < $go) return sprintf($exp_web5[3], $size / $mo, 2);
    if ($size < $to) return sprintf($exp_web5[4], $size / $go, 2);
    return sprintf($exp_web5[5], $size / $to, 2);
}

$exp_titre = ($lng == $lang[1]) ? $exp_name[1] : $exp_name[0];
htable($exp_titre, "100%");

// Displays the top message
echo (($lng == $lang[1]) ? $exp_message[1] : $exp_message[0]) . '<br />';

// VERIFICATIONS AND DATA
//********************************************************************************

// exp_currentFolder is the folder wich has been selected by the user (by clicking the folder image = submit button of one form)
$exp_currentFolder = isset($_POST['exp_currentFolder']) ? $_POST['exp_currentFolder'] : $exp_root;
$exp_currentFolder = empty($exp_currentFolder) ? $exp_root : strip_tags($exp_currentFolder);

// check the if the $exp_currentFolder is secure
if(strpos(realpath(CHEMIN . $exp_currentFolder), realpath(CHEMIN . $exp_root)) !== 0) {
    echo '<b>' . $exp_web1 . '</b>';
    btable();
    include(CHEMIN."inc/bpage.inc");
    die();
}

// CREATE AND DISPLAYS THE FOLDER TREE ABOVE THE SELECTED FOLDER (HOMEDIR)
//********************************************************************************

//displays the folder tree of this exp_currentFolder folder
$exp_currentFolderParts = explode('/', str_replace('\\', '/', $exp_currentFolder));
$exp_nbCurrentFolderParts = count($exp_currentFolderParts) -1;
$exp_nbRootParts = count(explode('/', $exp_root)) - 1;

$exp_prevFolder = '';
$textedecalage = '\--';
for ($i = $exp_nbRootParts - 1; $i < $exp_nbCurrentFolderParts; $i++) {
    $exp_prevFolder .= $exp_currentFolderParts[$i] . '/';
    echo '<form method="post" action="?lng=' . $lng . '" name="formulaire">
<input type="hidden" name="exp_currentFolder" value="' . $exp_prevFolder . '" />
<span style="font-family: Courrier">' . $textedecalage.'</span>
<input type="image" src="img/folder.gif" border="0" width="20px">&nbsp;&nbsp;' . $exp_currentFolderParts[$i] . '
</form>
';
    $textedecalage = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $textedecalage;
}

// displays current folder
echo '<fieldset><legend>' . $exp_web3 . '</legend>
<img alt="folder.gif" src="img/folder.gif" border="0" width="20px">&nbsp;<b>/'
. $exp_currentFolder . '</b></fieldset>
';

// EXPLORE THE FOLDERS, FIND THE FILES AND PUT THEIR INFORMATIONS IN PHP TABLES
//********************************************************************************

// Array of folder (0 => Address, 1 => Name)
$foldersArray = array();
$exp_fol = 0;
// Array of files (0=> Address, 1 => Name, 2 => Size, 3 => Counter, 4 => File icon)
$filesArray   = array();
$exp_fic = 0;

// Explore the folder
$dir = opendir(CHEMIN . $exp_currentFolder);
while (false !== ($file = readdir($dir))) {
    if (($file != '.') && ($file != '..') && ($file != 'index.php')) {
        // If it is a folder, put the following info in a table
        if (is_dir(CHEMIN . $exp_currentFolder . $file)) {
            // Address of the folder
            $foldersArray[$exp_fol][0] = $exp_currentFolder . $file ;
            // Name of the folder
            $foldersArray[$exp_fol][1] = $file ;
            $exp_fol++;
        }
        // else it is a file, we put the following info in a table
        else {
            // address of the file
            $filesArray[$exp_fic][0] = $exp_currentFolder . $file;
            // name of the file
            $filesArray[$exp_fic][1] = $file;
            // size of the file;
            $filesArray[$exp_fic][2] = convertSize(filesize(CHEMIN . $exp_currentFolder . $file));
            // counter value
            $exp_counterName = str_replace ('/', '_', $exp_currentFolder . $file . '.txt');
            if (file_exists(CHEMIN . 'data/plugins/' . $explorer_folder . '/counters/' . $exp_counterName)) {
                $filesArray[$exp_fic][3] = (int) trim(file_get_contents(CHEMIN . 'data/plugins/' . $explorer_folder . '/counters/' . $exp_counterName));
            } else {
                $filesArray[$exp_fic][3] = 0;
            }

            // find its extension and use it to give the file an icon
            $exp_fileType = substr($file, strrpos($file, '.') + 1);

            if ($exp_fileType == 'mp3' || $exp_fileType == 'ogg' || $exp_fileType == 'wma'
                    || $exp_fileType == 'wav' || $exp_fileType == 'mid') {
                $filesArray[$exp_fic][4] = 'im_audio.png';
            } elseif ($exp_fileType == 'avi' || $exp_fileType == 'wmv' || $exp_fileType == 'mpeg'
                    || $exp_fileType == 'mpg' || $exp_fileType == 'vob' || $exp_fileType == 'xvid'
                    || $exp_fileType == 'ra' || $exp_fileType == 'rm' || $exp_fileType == 'mov'
                    || $exp_fileType == 'mp+' || $exp_fileType == 'mpc') {
                $filesArray[$exp_fic][4] = 'im_video.png';
            } elseif ($exp_fileType == 'pdf' || $exp_fileType == 'ps') {
                $filesArray[$exp_fic][4] = 'im_pdf.png';
            } elseif ($exp_fileType == 'doc' || $exp_fileType == 'txt' || $exp_fileType == 'rtf'
                    || $exp_fileType == 'sxw' || $exp_fileType == 'sdw') {
                $filesArray[$exp_fic][4] = 'im_texte.png';
            } elseif ($exp_fileType == 'jpg' || $exp_fileType == 'gif' || $exp_fileType == 'png'
                    || $exp_fileType == 'bmp' || $exp_fileType == 'ico' || $exp_fileType == 'jp2'
                    || $exp_fileType == 'raw'|| $exp_fileType == 'tif') {
                $filesArray[$exp_fic][4]='im_image.png';
            } elseif ($exp_fileType == 'xls' || $exp_fileType == 'sxc' || $exp_fileType == 'pxl'
                    || $exp_fileType == 'sdc') {
                $filesArray[$exp_fic][4] = 'im_classeur.png';
            } elseif ($exp_fileType == 'tar' || $exp_fileType == 'zip' || $exp_fileType == 'gzip'
                    || $exp_fileType == '7z' || $exp_fileType == '7z' || $exp_fileType == 'bz2'
                    || $exp_fileType == 'gz') {
                $filesArray[$exp_fic][4]='im_zip.png';
            } elseif ($exp_fileType == 'htm' || $exp_fileType == 'html' || $exp_fileType == 'php'
                    || $exp_fileType == 'php3' || $exp_fileType == 'php5' || $exp_fileType == 'xml'
                    || $exp_fileType == 'css') {
                $filesArray[$exp_fic][4] = 'im_web.png';
            } else {
                $filesArray[$exp_fic][4] = 'im_reste.png';
            }

            $exp_fic++;
        }
    }
}

// done ! we close the folder
closeDir($dir);

// DISPLAYS THE FOLDERS AND FILES OF THE HOMEDIR
//********************************************************************************

$foldersArray = exp_sortData($foldersArray, 1, SORT_ASC);
$filesArray   = exp_sortData($filesArray,   1, SORT_ASC);

echo '<table id="explorerFileTable" border="0" cellpadding="5" style="text-align:right">
';

//display the folders
foreach($foldersArray as $folderArray) {
    echo '    <tr>
    <td colspan="3" style="text-align:left"><form method="post" action="?lng=' . $lng . '">
         <input type="hidden" name="exp_currentFolder" value="' . $folderArray[0] . '/" />
         <input type="image" src="img/folder.gif" alt="' . $folderArray[1] . '" width="20px"/>&nbsp;&nbsp;' . $folderArray[1] . '
         </form></td></tr>
';
}

//display the sorted files
foreach($filesArray as $fileArray) {
    //link between file type and icone
    echo '    <tr>
    <td style="text-align:left">
    <a target="_blank" href="clic.php?url=' . $fileArray[0] . '">
        <img alt="' . $fileArray[4] . '" src="img/' . $fileArray[4] . '" border="0" width="20" />
        &nbsp;&nbsp;' . $fileArray[1] . '</a>
    </td>
    <td>(<b>' . $fileArray[2] . '</b>)</td>
    <td>' . sprintf($exp_web4, $fileArray[3]) . '</td>
    </tr>
';
}
echo '</table>';
if (($serviz[32]=="on" && !empty($serviz[31]) && $serviz[31]==$userprefs[1])
    || ($serviz[32]=="on" && $drtuser['$explorer_folder']=="on")) {
    echo '<p align="right">
<a href="' . CHEMIN . 'admin/admin.php?lng=' . $lng . '&amp;pg=plugin&amp;plug=' . $explorer_folder . '/explorer">
<img src="' . CHEMIN . 'inc/img/general/edit.gif" border="0"  title="' . $web308 . '"></a></p>
';
}
btable();
include(CHEMIN . 'inc/bpage.inc');
?>
